/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package myuniversityproject20082009;

import java.sql.SQLException;

/**
 *
 * @author CHIHAOUI
 */
public class DataBase extends javax.swing.table.AbstractTableModel implements InterfaceDataBase {

    private final String DRIVER="sun.jdbc.odbc.JdbcOdbcDriver";
    private java.sql.Connection connection;
    private java.sql.Statement statement;
    private java.sql.ResultSet resultSet;
    private java.sql.ResultSetMetaData metaData;
    private String user="";
    private String password="";
    private String[] tab;
    private java.util.Vector rows=new java.util.Vector();
    
    /**
     * create a new dataBase as TableModel
     * @param url the url of the access file to make connection
     * @throws myuniversityproject20082009.ExceptionUniversity if url doesn't exist
     */
    public DataBase(String url) throws ExceptionUniversity{
        try{
        Class.forName(DRIVER);
        connection=java.sql.DriverManager.getConnection(url, user, password);
        statement=connection.createStatement(java.sql.ResultSet.TYPE_SCROLL_INSENSITIVE, java.sql.ResultSet.CONCUR_UPDATABLE);
        }
        catch(java.sql.SQLException ex){
            throw new ExceptionUniversity("Cannot Establish Connection with Data Base");
        }
        catch(java.lang.ClassNotFoundException ex2){
            throw new ExceptionUniversity("Cannot Establish Connection with Data Base");
        }
    }
    
    /**
     * execute query in parameter
     * @param query the query to do
     * @throws myuniversityproject20082009.ExceptionUniversity if the syntax of the query is not correct
     */
    public void executeQuery(String query) throws ExceptionUniversity{
        if(statement==null)
            throw new ExceptionUniversity("SQL Query is abscent");
        else{
            try{
            resultSet=statement.executeQuery(query);
            metaData=resultSet.getMetaData();
            int nb=metaData.getColumnCount();
            tab=new String[nb];
            for(int i=0;i<nb;i++){
                tab[i]=metaData.getColumnLabel(i+1);
            }
            while(resultSet.next()){
                java.util.Vector row=new java.util.Vector();
                for(int i=0;i<tab.length;i++){
                    row.add(resultSet.getObject(i+1));
                }
                rows.add(row);
            }
            }
            catch(java.sql.SQLException ex){
                throw new ExceptionUniversity("Cannot doing this query , there is a wrong");
            }
        }
    }
    
    /**
     * return the Object having rowIndex and columnIndex
     * @param rowIndex the index of the row
     * @param columnIndex the index of the column
     * @return the Object having rowIndex and columnIndex
     */
    public Object getValueAt(int rowIndex, int columnIndex) {
        return ((java.util.Vector)rows.get(rowIndex)).get(columnIndex);
    }

    /**
     * return the numbre of the columns
     * @return the numbre of the columns
     */
    public int getColumnCount() {
        return tab.length;
    }

    /**
     * return the numbre of the rows
     * @return the numbre of the rows
     */
    public int getRowCount() {
        return rows.size();
    }
    
    /**
     * closing all modifiers
     * @throws java.sql.SQLException
     */
    public void close(){
        try{
        System.out.println("Closing db connection");
        resultSet.close();
        statement.close();
        connection.close();
        }catch(java.sql.SQLException ex){
            ex.printStackTrace();
        }
    }

    /**
     * return the column name having the column in parameter
     * @param column the index of the column
     * @return the column name having the column in parameter
     */
    @Override
    public String getColumnName(int column) {
        if (tab[column] != null) {
            return tab[column];
        } else {
            return "";
        }
    }
}
