/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myuniversityproject20082009;

/**
 *
 * @author CHIHAOUI
 */
public class Institute implements InterfaceInstitute,java.io.Serializable,java.lang.Comparable<Institute> {

    private InterfaceStudents students;
    private InterfaceTeachers teachers;
    private InterfaceCode code;
    private InterfaceName name;

    /**
     * Creates a new instance of Institute
     */
    public Institute() {
        students = new Students();
        teachers = new Teachers();
        code = new Code();
    }
    
    /**
     * Creates a new instance of Institute
     */
    public Institute(int code,String name) {
        students = new Students();
        teachers = new Teachers();
        this.code = new Code();
        this.name=new Name();
        this.code.setCode(code);
        this.name.setName(name);
    }

    /**
     * 
     * @return the code of the institute
     */
    public int getCode() {
        return code.getCode();
    }

    /**
     * 
     * @param code the new code to affect
     */
    public void setCode(int code) {
        this.code.setCode(code);
    }
    
    /**
     * 
     * @return the name of the institute
     */
    public String getName() {
        return name.getName();
    }

    /**
     * 
     * @param name the new name to affect
     */
    public void setName(String name) {
        this.name.setName(name);
    }

    /**
     * 
     * @return the number of student in the List Of Students
     */
    public int getNumberStudents() {
        return students.getSize();
    }

    /**
     * 
     * @return true if the List Of Students is empty, false if not
     */
    public boolean isSetStudentIsEmpty() {
        return students.isEmpty();
    }

    /**
     * 
     * @param student add student to the List Of Students
     */
    public boolean addStudent(Student student) {
        return students.addStudent(student);
    }

    /**
     * 
     * @param code the code of student
     * @return the student having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Student getStudent(int code) throws ExceptionUniversity {
        return students.getStudent(code);
    }

    /**
     * 
     * @param code the code of student to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setStudent(int code, int code2, String name, int age) throws ExceptionUniversity {
        students.setStudent(code, code2, name, age);
    }

    /**
     * 
     * @param code code of the student
     * @return true if the associated student to the code is in the List Of Students
     */
    public boolean isExistStudent(int code) {
        return students.isExist(code);
    }

    /**
     * 
     * @param code delete the student having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the student having the code doesn't exist
     */
    public void deleteStudent(int code) throws ExceptionUniversity {
       students.delete(code);
    }

    /**
     * 
     * @return the List Of Students as String
     */
    public String toStringStudents() {
       return students.toString();
    }

    /**
     * 
     * @return the number of teacher in the Collection Of Teachers
     */
    public int getSizeTeachers() {
        return teachers.getSize();
    }

    /**
     * 
     * @return true if the Collection Of Teachers is empty, false if not
     */
    public boolean isSetTeacherIsEmpty() {
        return teachers.isEmpty();
    }

    /**
     * 
     * @param teacher add teacher to the Collection Of Teachers
     */
    public boolean addTeacher(Teacher teacher) {
        return teachers.addTeacher(teacher);
    }

    /**
     * 
     * @param code the code of teacher
     * @return the teacher having the code in param
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public Teacher getTeacher(int code) throws ExceptionUniversity {
        return teachers.getTeacher(code);
    }

    /**
     * 
     * @param code the code of teacher to search for
     * @param code2 the new code to affect
     * @param name the new name to affect
     * @param age the new age to affect
     * @throws myuniversityproject20082009.ExceptionUniversity
     */
    public void setTeacher(int code, int code2, String name, int age) throws ExceptionUniversity {
        teachers.setTeacher(code, code2, name, age);
    }

    /**
     * 
     * @param code code of the teacher
     * @return true if the associated teacher to the code is in the Collection Of Teachers
     */
    public boolean isExistTeacher(int code) {
        return teachers.isExist(code);
    }

    /**
     * 
     * @param code delete the teacher having thye associated code
     * @throws myuniversityproject20082009.ExceptionUniversity if the teacher having the code doesn't exist
     */
    public void deleteTeacher(int code) throws ExceptionUniversity {
        teachers.delete(code);
    }

    /**
     * 
     * @return the Collection Of Teachers as String
     */
    public String toStringTeachers() {
        return teachers.toString();
    }
    
    public int compareTo(Institute institute){
        if(this.getCode()>institute.getCode())
            return 1;
        else
            if(this.getCode()<institute.getCode())
                return -1;
            else
                return 0;
    }
    @Override
    public String toString(){
        return "The institute name is :"+this.getName()+" The Code is :"+this.getCode();
    }
}
